package eu.lindenbaum.lab.racetest;

import java.util.concurrent.ExecutionException;

import co.paralleluniverse.fibers.SuspendExecution;

public class Main {
  public static void main(String[] args) throws SuspendExecution, InterruptedException, ExecutionException {
    scenarioOne();
  }

  private static void scenarioOne() throws SuspendExecution, InterruptedException, ExecutionException {
    final int NUM_PARENTS = 10;
    final int NUM_CHILDREN_PER_PARENT = 100_000;
    RootActor rootActor = new RootActor();
    rootActor.spawn();

    // create all
    for (int i = 1; i <= NUM_PARENTS; i++) {
      System.err.println("[MAIN] Asking creation of new parent");
      rootActor.ref().send(CreateParentMessage.INSTANCE);
      for (int j = 1; j <= NUM_CHILDREN_PER_PARENT; j++) {
        System.err.println("[MAIN] Asking creation of new child for parent " + i);
        rootActor.ref().send(new CreateChildForParentMessage(Integer.toString(i)));
      }
    }

    // shutdown all
    System.err.println("[MAIN] Asking shutdown");
    rootActor.ref().send(ShutdownMessage.INSTANCE);

    System.err.println("[MAIN] Joining");
    rootActor.join();
  }
}
